<template>
  <section id="vlue-dev-image-select"
    :class="{ display : Object.keys(imageSelectParams).length }">
    <section id="vlue-dev-image-select-top">
      <h3>Image Select</h3>
      <input class="vlue-dev-sidebar-button vlue-dev-sidebar-back-button"
        type="button"
        v-on:click="hideImageSelect()"
        value="<">
      <input id="upload-image-file-input"
        type="file"
        v-on:change="uploadImage"
        accept="image/jpeg, image/jpg, image/png">
      <input class="vlue-dev-sidebar-button"
        type="button"
        v-on:click="uploadImageClick()"
        value="Upload Image">
    </section>
    <section id="vlue-dev-image-select-main">
      <sidebar-property-field
        :current="imageSelectParams.current"
        :global="imageSelectParams.global"
        :prop="prop('')">
      </sidebar-property-field>
      <sidebar-property-field
        v-for="(image, index) in images"
        :current="imageSelectParams.current"
        :global="imageSelectParams.global"
        :prop="prop(image)"
        :key="index">
      </sidebar-property-field>
    </section>
  </section>
</template>

<script lang="ts">
import Vue from 'vue'
import sidebarPropertyField from './SidebarPropertyField.vue'
import store from '../../store/store'
import { mapState } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'imageSelectParams',
      'images',
    ]),
  },
  components: {
    sidebarPropertyField,
  },
  methods: {
    hideImageSelect() {
      store.commit('hideImageSelect');
    },
    uploadImage(event) {
      store.commit('uploadImage', {
        image: event.target.files[0],
      });
      // reset value so that change event is triggered even when selecting the same file again
      event.target.value = null;
    },
    uploadImageClick() {
      document.getElementById('upload-image-file-input')?.click();
    },
    prop(image) {
      return {
        ...this.imageSelectParams.property,
        value: image,
      };
    },
  },
})
</script>

<style lang="scss">
@import "../../style/vars.scss";

.vlue-dev-sidebar-image-select-button {
  background-size: cover;
  background-position: center;
  height: 100px;
  border: 0 solid rgba(0,0,0,0.5);
  background-color: rgba(0,0,0,0.4);
  box-shadow: inset 0 10px 10px rgba(0,0,0,0.2);
  &:enabled:not(.selected) {
    &:hover {
      border-width: 10px;
    }
    &:hover,
    &:active {
      box-shadow: 0 0 10px rgba(0,0,0,0.75) inset;
    }
  }
}

#vlue-dev-image-select {
  display: none;
  overflow: hidden;
  flex-direction: column;
  position: fixed;
  top: 0;
  right: - $vlue-dev-sidebar-width;
  width: $vlue-dev-sidebar-width;
  height: 100vh;
  background: $vlue-dev-bg-color;
  transition: $vlue-transition-duration;
  &.display {
    right: - $standard-scrollbar-width;
  }
  #vlue-dev-image-select-top {
    padding-top: 10px;
    box-shadow: 0 10px 10px rgba(0,0,0,0.5);
    * {
      width: calc(100% - 40px);
    }
    input[type="file"] {
      display: none;
    }
  }
  #vlue-dev-image-select-main {
    overflow-y: scroll;
    padding: 50px 0;
  }
}
.dev #vlue-dev-image-select {
  display: flex;
}
</style>
